#! /usr/bin/env python

# import standard modules

# import custom modules
from utils.general import RemoveIndexingFlag
from utils.messages import DebugMsg, ExtremeDebugMsg
from parsers.tokenizer import TokenizerCls

# constants

class OverlapResultCls: #{
  def __init__(self, data_str, log_info=None): #{
    ExtremeDebugMsg(log_info, "Parsing overlap line...")
    tokenizer = TokenizerCls(data_str, delimiter=" ",
      log_info=log_info)
    ExtremeDebugMsg(log_info, "Parsing chromosome")
    self.chrom = tokenizer.next()
    ExtremeDebugMsg(log_info, "Parsing start, end, and query_id")
    for attr in ["start", "end"]: #{
      setattr(self, attr, int(tokenizer.next()))
    #} end for
    self.query_id = tokenizer.next()
    self.raw_result = tokenizer.next()
  #} end def

  def __str__(self): #{
    return self.ToString()
  #} end def

  def ResultList(self): #{
    return map(RemoveIndexingFlag, self.raw_result.strip("^").split("^"))
  #} end def

  def NumID(self): #{
    return int(self.query_id)
  #} end def

  def ToString(self): #{
    return " ".join([self.chrom, "%i" % self.start, "%i" % self.end,
        self.query_id, ",".join(self.ResultList())])
  #} end def
#} end class
